public class Pascal01
{   
   /**
    * Test driver entry point.
    *
    * @param args   Command-line parameters
    */
   public static void main(String[] args)
   {
      if (args.length == 0 || args[0] == null || args[0].equals(""))
      {
         System.out.println("java Pascal01 <Source Filename>");
         return;
      }

      PascalParser pp = new PascalParser(args[0]);

      pp.compile();
      
      /* Stolen from PascalParser.java */
      String filename, baseFilename, outputFilename;

      filename = args[0];

      int lastpos = filename.lastIndexOf(".");

      if (lastpos != -1)
         baseFilename = filename.substring(0,lastpos);
      else
         baseFilename = filename;

      outputFilename = baseFilename + ".o";

      TargetArchitecture ta = new TargetArchitecture();
      ta.readObjectFile(outputFilename);
      ta.executeInstructions();
   }
}
