PROGRAM Matrix;
        CONST
                N = 4;
                A = 16807; M = 2147483647; Q = M DIV A; R = M MOD A;

        TYPE
                Vector = ARRAY 4 OF INTEGER;
                Matrix = ARRAY 4 OF Vector;

        VAR
        		x: INTEGER;
        		m1, m2, m3: Matrix;


        PROCEDURE InitMatrix(VAR m: Matrix; z: INTEGER);

                VAR i, j, g: INTEGER;

        BEGIN

                i := 0;

                WHILE i < N DO

                        j := 0;

                        WHILE j < N DO

                                g := A * (z MOD Q) - R * (z DIV Q);

                                IF g > 0 THEN z := g ELSE z := g + M END;

                                m[j][i] := 50 - (z MOD 100);

                                j := j + 1

                        END;

                        i := i + 1

                END;

        END InitMatrix;



        PROCEDURE OutMatrix(VAR m: Matrix);

                VAR i, j: INTEGER;

        BEGIN

                i := 0;

                WHILE i < N DO

                        j := 0;

                        WHILE j < N DO

                                WriteInt(m[j][i]);

                                j := j + 1

                        END;

                        i := i + 1; WriteLn

                END; WriteLn

        END OutMatrix;



        PROCEDURE MatMult (VAR m1, m2, m3 : Matrix);

                VAR s, i, j, k: INTEGER;

        BEGIN

                s := 0; i := 0;

                WHILE i < N DO

                        j := 0;

                        WHILE j < N DO

                                k := 0; s := 0;

                                WHILE k < N DO

                                        s := s + m1[k][j] * m2[i][k];

                                        k := k+1

                                END;

                                m3[i][j] := s; j := j+1

                        END;

                        i := i+1

                END

        END MatMult;





BEGIN

        x := 8;

        InitMatrix(m1, x); OutMatrix(m1);

        InitMatrix(m2, x+4); OutMatrix(m2);

        MatMult(m1, m2, m3); OutMatrix(m3)

END.
